<?php

namespace Neuron\Person\Controller;
use Neuron\Application\Framework\Entity;

use Neuron\Person\Entity as personEntity;
use Neuron\Person\Entities as personEntitys;
use Neuron\Person\Attribute as personAttribute;

class Affiliate extends \Neuron\Person\Controller {
    protected function getView($name, $variables = array()) {

		/* default layout & view prefix */
		$layout = 'neuron/person/layout/form';
		$prefix = 'neuron/person/affiliate';

		/* libraries */
		if(! class_exists('Neuron\Application\Framework\Entity')) {
			$this->using(
                'bootstrap-4',
                null,
                array(
                    'https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js',
                    'https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js',
                    'https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css',
                    'https://maxcdn.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js'
                )
			);
		}

		/* get layout n view prefix from config */
		$config = $this->getConfig();
		if (isset($config['document'])) {
				$config = $config['document'];
				$layout = isset($config['formlayout']) ? $config['formlayout'] : $layout;
				$prefix = isset($config['viewprefix']) ? $config['viewprefix'] : $prefix;
		}

		/* set layout and view */
		$this->layout($layout);
		$view = new \Zend\View\Model\ViewModel($variables);
		$view->setTemplate($prefix . '/' . strtolower($name));

		return $view;
	}

    public function indexAction() {
		$sessmgt 	= $this->getSession();
		$ref_id 	= $sessmgt->owner();
		$user		= $sessmgt->get();
		$name   	= $user['name'];

		# check maping user to person ['BEGIN']
		$storage = personEntity\Storage::factory($this->getDb(), $this->getConfig());
		$cpersons = new personEntity($storage);

		$dataMapping = $cpersons->loadMap($ref_id,"user_id");

		if($dataMapping) {
			# check registrar afiliate ['BEGIN']
			$dataMap['person_id'] = $dataMapping['person_id'];
			$dataMap['attr_code'] = 'AFF';
			$astorage = personAttribute\Storage::factory($this->getDb(),$this->getConfig());
			$apersons = new personAttribute($astorage);
			$attributes = $apersons->load($dataMap,$mode = personAttribute\Storage::LOADBY_PERSONID_ATTR_CODE_EXP_DATE);
			
			if($attributes) {
				$setDisplay = 1;
				$affiliatecode = $attributes['attr_value'];
			} else {
				$setDisplay = 0;
				$affiliatecode = null;
			}

			# check registrar afiliate ['END']
		}

		# check maping user to person ['BEGIN']
		

        return $this->getView('generate', get_defined_vars());
    }

	public function generateAction() {
		$result			= new \Neuron\Generic\Result();
		$post 			= $this->getREST()->getParameters();
		$sessmgt 		= $this->getSession();
		$ref_id 		= $sessmgt->owner();

		$storage = personEntity\Storage::factory($this->getDb(), $this->getConfig());
		$cpersons = new personEntity($storage);

		$dataMapping = $cpersons->loadMap($ref_id,"user_id");
		$specialChar = $this->incrementalHash();

		// $uniqueCode = hash("md5",$sessmgt->get()['code']." - affiliate - ". date('Y-m-d'));
		$data['code'] 	= 'AFF';
		$data['person_id']	= $dataMapping['person_id'];
		$data['value'] = strtolower($dataMapping['first_name'].$dataMapping['last_name']).$specialChar;
		$data['update_by'] = $ref_id;

		$storage = personAttribute\Storage::factory($this->getDb(),$this->getConfig());
		$attributes = new personAttribute($storage);
		$attribute = $attributes->saveAttr($data);
		
		if ($attribute){
			#load data attribute
			$dataMap['person_id'] = $dataMapping['person_id'];
			$dataMap['attr_code'] = 'AFF';
			$result->data = $attributes->load($dataMap,$mode = personAttribute\Storage::LOADBY_PERSONID_ATTR_CODE);
		} else {
			$result->code = 1;
			$result->data = null;
		}
		
		return $this->getREST()->getResponse($result);
	}

	public function saveCodeAction(){
		$result			= new \Neuron\Generic\Result();

		$post 			= $this->getREST()->getParameters();
		$sessmgt 		= $this->getSession();
		$ref_id 		= $sessmgt->owner();

		$storage = personEntity\Storage::factory($this->getDb(), $this->getConfig());
		$cpersons = new personEntity($storage);

		$dataMapping = $cpersons->loadMap($ref_id,"user_id");

		$id['person_id'] = $dataMapping['person_id'];
		$id['attr_code'] = 'AFF';

		$storage = personAttribute\Storage::factory($this->getDb(),$this->getConfig());
		$attributes = new personAttribute($storage);

		# check kode yang masih aktif
		$checkCode = $attributes->load($id,personAttribute\Storage::LOADBY_PERSONID_ATTR_CODE_EXP_DATE);

		if ($checkCode) {
			if ($post['affiliateCode'] == $checkCode['attr_value']){
				$result->code = 1;
				$result->data = null;
				$result->info = $this->translate('Affiliate code cannot be the same');
			} else {
				# terminate kode yang masih aktif
				$data = $attributes->pull();
				$data['end_date'] 			 = date('Y-m-d H:i:s');
				$terminate = $attributes->saveAttributeAffiliate($data, $ref_id );

				#jika berhasil di terminate buat attribute baru dengan id baru
				if($terminate->code == 0){
				
					$id['attr_value'] = $post['affiliateCode'];
					$id['start_date'] = date('Y-m-d H:i:s');
					$createNew = $attributes->saveAttributeAffiliate($id, $ref_id );
					
					if($createNew->code == 0){
					
						$result->data = $createNew->data;
						$result->info = $this->translate('Affiliate code has been updated');
					}
				} else {
					$result->code = 1;
					$result->data = null;
					$result->info = $this->translate('Failed to terminate affiliate code');
				}
			}
		} else {
			$result->code = 1;
			$result->data = null;
			$result->info = 'Kode affiliasi tidak ditemukan';
		}

		return $this->getREST()->getResponse($result);

	}

	public function incrementalHash($len = 5){
		$charset = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
		$base = strlen($charset);
		$result = '';
	  
		$now = explode(' ', microtime())[1];
		while ($now >= $base){
		  $i = $now % $base;
		  $result = $charset[$i] . $result;
		  $now /= $base;
		}
		return substr($result, -5);
	}

	public function affiliateReportAction(){
		return $this->getView('affiliatereport', get_defined_vars());
	}

	public function customerReportAction(){
		return $this->getView('customerreport', get_defined_vars());
	}
}
	
