<?php
namespace Neuron\Person;

use Neuron\Generic\Entity\Map;
use Neuron\Generic\Result;

class Religion extends \Neuron\Generic\Entity\Mapper {

    protected $_storage;

    public function __construct(Religion\Storage\Skeleton $storage) {

        /* simpan storage */
        $this->_storage = $storage;

        /* map properti ke tabel */
        parent::__construct(
            array(),
            array(
                new Map('religion_id'),
                new Map('name'),
            ),
            parent::CASE_INSENSITIVE
        );
    }

    public function load($id, $mode = Religion\Storage::LOADBY_ID) {

        /* query */
        if ($data = $this->_storage->load($id, $mode)) {
            
            $this->push($data);

            /* berhasil */
            return $this->id;
        }

        /* default gagal */
        return false;
    }

    public function save($update = false) {

        /* simpan */
        if ($id = $this->_storage->save($this, $update)) {

            /* set id */
            $this->id = $id;
            return $id;
        }

        /* return hasil */
        return false;
    }
}
